<template>
  <section>
    <h4>Given an integer n, Find the sum of 1<sup>1</sup> + 2<sup>2</sup> + 3<sup>3</sup> + ..... + n<sup>n</sup></h4>
    <div id="searchBox">
      <label id="inputExponent">
        Enter exponent:
        <input v-model="exponent" oninput="this.value=this.value.replace(/[^0-9]/g,'');" @keyup.enter="sumExponent"></input>
      </label>
      <button @click="sumExponent">Check sum</button>
    </div>
    <p v-if="result !== ''">
      Sum exponent result:
      <template v-for="item in +exponent">
        <span>{{ item }}<sup>{{ item }}</sup></span>
        <span v-if="+exponent !== item">+ </span>
      </template>
      {{`= ${sumText} = ${result}`}}
    </p>
  </section>
</template>

<script>
  export default {
    data() {
      return {
        exponent: '',
        result: '',
        sumText: ''
      }
    },
    watch: {
      exponent() {
        const vm = this
        vm.result = ''
      }
    },
    methods: {
      sumExponent() {
        const vm = this
        if (vm.exponent) {
          let exponent = +vm.exponent
          let sum = 0
          let sumText = ''
          if (exponent > 0) {
            // logic
            for (let i = 1; i <= exponent; i++) {
              // ่check sum by Math.pow
              // sum += Math.pow(i, i)
              // sumText += Math.pow(i, i) + (exponent !== i ? '+' : '')

              // Don't like Math.pow
              let num = 1
              for (let j = 1; j <= i; j++) {
                num = num*i
              }
              sum += num
              sumText += num + (exponent !== i ? '+' : '')
            }
              vm.sumText = sumText
              vm.result = sum
          } else {
              vm.sumText = 0
              vm.result = 0
          }
        }
      }
    }
  }
</script>

<style scoped>
  input {
    outline: none;
    border-radius: 4px !important;
    border: solid 1px #c4c4c4 !important;
    background-color: #ffffff;
    padding: 5px 10px 5px 10px;
  }
  input:focus {
    border: 1px solid #36a3f7 !important;
    border-radius: 4px;
  }
  button {
    cursor: pointer;
    outline: none;
    border: none !important;
    padding: 5px;
    border-radius: 5px;
    background: #3b8aff;
    color: white;
    box-shadow: 0px 3px 1px -2px rgba(0, 0, 0, 0.2),
    0px 2px 2px 0px rgba(0, 0, 0, 0.14),
    0px 1px 5px 0px rgba(0, 0, 0, 0.1)
  }
  p {
    word-break: break-word;
  }
</style>